<template>
  <div>
    <slot></slot>
  </div>
</template>

<script>
import {
  getTagsTranslations as getTagsTranslationsAction,
  getAllHostelCategories as getAllHostelCategoriesAction
} from "@/actions/TagsCategoriesAction";
import {provideMethods} from "../libs/genProvider";

export default {
  name: "TranslationProvider",
  data: () => ({
    translationsTags: {},
    hostelCategoriesById: {},
  }),
  provide() {
    const provider = {};

    provideMethods(provider, 'translation', this);

    return provider;
  },
  methods: {
    displayTagOrCategory(elem, type /* 'tag'|'category' */) {
      return type === 'tag' ?
          this.translationsTags[elem]??elem :
          (this.hostelCategoriesById[elem] ? this.hostelCategoriesById[elem].name : elem)
    },
    getHostelDatas() {
      getAllHostelCategoriesAction()
          .then(hostels => {
            this.hostelCategoriesById = hostels.reduce((acc,hostel) => ({
              ...acc,
              [hostel.id]: hostel,
            }), {});
          })
    },
    getTagsTranslations() {
      getTagsTranslationsAction()
          .then(res => res.json())
          .then(translationsTags => {
            this.translationsTags = translationsTags;
          })
    },
    getHostelSynonyms(id) {
      return this.hostelCategoriesById[id] ? this.hostelCategoriesById[id].synonyms : [];
    }
  },
  beforeMount() {
    this.getHostelDatas();
    this.getTagsTranslations();
  }
}
</script>

<style scoped>

</style>